// Code generated by entc, DO NOT EDIT.

package metrics

import (
	"time"

	"entgo.io/ent/dialect/sql"
	"github.com/vorteil/direktiv/pkg/metrics/ent/predicate"
)

// ID filters vertices based on their ID field.
func ID(id int) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldID), id))
	})
}

// IDEQ applies the EQ predicate on the ID field.
func IDEQ(id int) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldID), id))
	})
}

// IDNEQ applies the NEQ predicate on the ID field.
func IDNEQ(id int) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldID), id))
	})
}

// IDIn applies the In predicate on the ID field.
func IDIn(ids ...int) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(ids) == 0 {
			s.Where(sql.False())
			return
		}
		v := make([]interface{}, len(ids))
		for i := range v {
			v[i] = ids[i]
		}
		s.Where(sql.In(s.C(FieldID), v...))
	})
}

// IDNotIn applies the NotIn predicate on the ID field.
func IDNotIn(ids ...int) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(ids) == 0 {
			s.Where(sql.False())
			return
		}
		v := make([]interface{}, len(ids))
		for i := range v {
			v[i] = ids[i]
		}
		s.Where(sql.NotIn(s.C(FieldID), v...))
	})
}

// IDGT applies the GT predicate on the ID field.
func IDGT(id int) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldID), id))
	})
}

// IDGTE applies the GTE predicate on the ID field.
func IDGTE(id int) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldID), id))
	})
}

// IDLT applies the LT predicate on the ID field.
func IDLT(id int) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldID), id))
	})
}

// IDLTE applies the LTE predicate on the ID field.
func IDLTE(id int) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldID), id))
	})
}

// Namespace applies equality check predicate on the "namespace" field. It's identical to NamespaceEQ.
func Namespace(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldNamespace), v))
	})
}

// Workflow applies equality check predicate on the "workflow" field. It's identical to WorkflowEQ.
func Workflow(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldWorkflow), v))
	})
}

// Instance applies equality check predicate on the "instance" field. It's identical to InstanceEQ.
func Instance(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldInstance), v))
	})
}

// State applies equality check predicate on the "state" field. It's identical to StateEQ.
func State(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldState), v))
	})
}

// Timestamp applies equality check predicate on the "timestamp" field. It's identical to TimestampEQ.
func Timestamp(v time.Time) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldTimestamp), v))
	})
}

// WorkflowMs applies equality check predicate on the "workflow_ms" field. It's identical to WorkflowMsEQ.
func WorkflowMs(v int64) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldWorkflowMs), v))
	})
}

// IsolateMs applies equality check predicate on the "isolate_ms" field. It's identical to IsolateMsEQ.
func IsolateMs(v int64) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldIsolateMs), v))
	})
}

// ErrorCode applies equality check predicate on the "error_code" field. It's identical to ErrorCodeEQ.
func ErrorCode(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldErrorCode), v))
	})
}

// Invoker applies equality check predicate on the "invoker" field. It's identical to InvokerEQ.
func Invoker(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldInvoker), v))
	})
}

// Next applies equality check predicate on the "next" field. It's identical to NextEQ.
func Next(v int8) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldNext), v))
	})
}

// Transition applies equality check predicate on the "transition" field. It's identical to TransitionEQ.
func Transition(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldTransition), v))
	})
}

// NamespaceEQ applies the EQ predicate on the "namespace" field.
func NamespaceEQ(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldNamespace), v))
	})
}

// NamespaceNEQ applies the NEQ predicate on the "namespace" field.
func NamespaceNEQ(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldNamespace), v))
	})
}

// NamespaceIn applies the In predicate on the "namespace" field.
func NamespaceIn(vs ...string) predicate.Metrics {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Metrics(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.In(s.C(FieldNamespace), v...))
	})
}

// NamespaceNotIn applies the NotIn predicate on the "namespace" field.
func NamespaceNotIn(vs ...string) predicate.Metrics {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Metrics(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.NotIn(s.C(FieldNamespace), v...))
	})
}

// NamespaceGT applies the GT predicate on the "namespace" field.
func NamespaceGT(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldNamespace), v))
	})
}

// NamespaceGTE applies the GTE predicate on the "namespace" field.
func NamespaceGTE(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldNamespace), v))
	})
}

// NamespaceLT applies the LT predicate on the "namespace" field.
func NamespaceLT(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldNamespace), v))
	})
}

// NamespaceLTE applies the LTE predicate on the "namespace" field.
func NamespaceLTE(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldNamespace), v))
	})
}

// NamespaceContains applies the Contains predicate on the "namespace" field.
func NamespaceContains(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.Contains(s.C(FieldNamespace), v))
	})
}

// NamespaceHasPrefix applies the HasPrefix predicate on the "namespace" field.
func NamespaceHasPrefix(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.HasPrefix(s.C(FieldNamespace), v))
	})
}

// NamespaceHasSuffix applies the HasSuffix predicate on the "namespace" field.
func NamespaceHasSuffix(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.HasSuffix(s.C(FieldNamespace), v))
	})
}

// NamespaceEqualFold applies the EqualFold predicate on the "namespace" field.
func NamespaceEqualFold(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.EqualFold(s.C(FieldNamespace), v))
	})
}

// NamespaceContainsFold applies the ContainsFold predicate on the "namespace" field.
func NamespaceContainsFold(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.ContainsFold(s.C(FieldNamespace), v))
	})
}

// WorkflowEQ applies the EQ predicate on the "workflow" field.
func WorkflowEQ(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldWorkflow), v))
	})
}

// WorkflowNEQ applies the NEQ predicate on the "workflow" field.
func WorkflowNEQ(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldWorkflow), v))
	})
}

// WorkflowIn applies the In predicate on the "workflow" field.
func WorkflowIn(vs ...string) predicate.Metrics {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Metrics(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.In(s.C(FieldWorkflow), v...))
	})
}

// WorkflowNotIn applies the NotIn predicate on the "workflow" field.
func WorkflowNotIn(vs ...string) predicate.Metrics {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Metrics(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.NotIn(s.C(FieldWorkflow), v...))
	})
}

// WorkflowGT applies the GT predicate on the "workflow" field.
func WorkflowGT(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldWorkflow), v))
	})
}

// WorkflowGTE applies the GTE predicate on the "workflow" field.
func WorkflowGTE(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldWorkflow), v))
	})
}

// WorkflowLT applies the LT predicate on the "workflow" field.
func WorkflowLT(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldWorkflow), v))
	})
}

// WorkflowLTE applies the LTE predicate on the "workflow" field.
func WorkflowLTE(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldWorkflow), v))
	})
}

// WorkflowContains applies the Contains predicate on the "workflow" field.
func WorkflowContains(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.Contains(s.C(FieldWorkflow), v))
	})
}

// WorkflowHasPrefix applies the HasPrefix predicate on the "workflow" field.
func WorkflowHasPrefix(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.HasPrefix(s.C(FieldWorkflow), v))
	})
}

// WorkflowHasSuffix applies the HasSuffix predicate on the "workflow" field.
func WorkflowHasSuffix(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.HasSuffix(s.C(FieldWorkflow), v))
	})
}

// WorkflowEqualFold applies the EqualFold predicate on the "workflow" field.
func WorkflowEqualFold(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.EqualFold(s.C(FieldWorkflow), v))
	})
}

// WorkflowContainsFold applies the ContainsFold predicate on the "workflow" field.
func WorkflowContainsFold(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.ContainsFold(s.C(FieldWorkflow), v))
	})
}

// InstanceEQ applies the EQ predicate on the "instance" field.
func InstanceEQ(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldInstance), v))
	})
}

// InstanceNEQ applies the NEQ predicate on the "instance" field.
func InstanceNEQ(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldInstance), v))
	})
}

// InstanceIn applies the In predicate on the "instance" field.
func InstanceIn(vs ...string) predicate.Metrics {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Metrics(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.In(s.C(FieldInstance), v...))
	})
}

// InstanceNotIn applies the NotIn predicate on the "instance" field.
func InstanceNotIn(vs ...string) predicate.Metrics {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Metrics(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.NotIn(s.C(FieldInstance), v...))
	})
}

// InstanceGT applies the GT predicate on the "instance" field.
func InstanceGT(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldInstance), v))
	})
}

// InstanceGTE applies the GTE predicate on the "instance" field.
func InstanceGTE(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldInstance), v))
	})
}

// InstanceLT applies the LT predicate on the "instance" field.
func InstanceLT(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldInstance), v))
	})
}

// InstanceLTE applies the LTE predicate on the "instance" field.
func InstanceLTE(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldInstance), v))
	})
}

// InstanceContains applies the Contains predicate on the "instance" field.
func InstanceContains(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.Contains(s.C(FieldInstance), v))
	})
}

// InstanceHasPrefix applies the HasPrefix predicate on the "instance" field.
func InstanceHasPrefix(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.HasPrefix(s.C(FieldInstance), v))
	})
}

// InstanceHasSuffix applies the HasSuffix predicate on the "instance" field.
func InstanceHasSuffix(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.HasSuffix(s.C(FieldInstance), v))
	})
}

// InstanceEqualFold applies the EqualFold predicate on the "instance" field.
func InstanceEqualFold(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.EqualFold(s.C(FieldInstance), v))
	})
}

// InstanceContainsFold applies the ContainsFold predicate on the "instance" field.
func InstanceContainsFold(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.ContainsFold(s.C(FieldInstance), v))
	})
}

// StateEQ applies the EQ predicate on the "state" field.
func StateEQ(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldState), v))
	})
}

// StateNEQ applies the NEQ predicate on the "state" field.
func StateNEQ(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldState), v))
	})
}

// StateIn applies the In predicate on the "state" field.
func StateIn(vs ...string) predicate.Metrics {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Metrics(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.In(s.C(FieldState), v...))
	})
}

// StateNotIn applies the NotIn predicate on the "state" field.
func StateNotIn(vs ...string) predicate.Metrics {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Metrics(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.NotIn(s.C(FieldState), v...))
	})
}

// StateGT applies the GT predicate on the "state" field.
func StateGT(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldState), v))
	})
}

// StateGTE applies the GTE predicate on the "state" field.
func StateGTE(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldState), v))
	})
}

// StateLT applies the LT predicate on the "state" field.
func StateLT(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldState), v))
	})
}

// StateLTE applies the LTE predicate on the "state" field.
func StateLTE(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldState), v))
	})
}

// StateContains applies the Contains predicate on the "state" field.
func StateContains(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.Contains(s.C(FieldState), v))
	})
}

// StateHasPrefix applies the HasPrefix predicate on the "state" field.
func StateHasPrefix(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.HasPrefix(s.C(FieldState), v))
	})
}

// StateHasSuffix applies the HasSuffix predicate on the "state" field.
func StateHasSuffix(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.HasSuffix(s.C(FieldState), v))
	})
}

// StateEqualFold applies the EqualFold predicate on the "state" field.
func StateEqualFold(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.EqualFold(s.C(FieldState), v))
	})
}

// StateContainsFold applies the ContainsFold predicate on the "state" field.
func StateContainsFold(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.ContainsFold(s.C(FieldState), v))
	})
}

// TimestampEQ applies the EQ predicate on the "timestamp" field.
func TimestampEQ(v time.Time) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldTimestamp), v))
	})
}

// TimestampNEQ applies the NEQ predicate on the "timestamp" field.
func TimestampNEQ(v time.Time) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldTimestamp), v))
	})
}

// TimestampIn applies the In predicate on the "timestamp" field.
func TimestampIn(vs ...time.Time) predicate.Metrics {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Metrics(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.In(s.C(FieldTimestamp), v...))
	})
}

// TimestampNotIn applies the NotIn predicate on the "timestamp" field.
func TimestampNotIn(vs ...time.Time) predicate.Metrics {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Metrics(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.NotIn(s.C(FieldTimestamp), v...))
	})
}

// TimestampGT applies the GT predicate on the "timestamp" field.
func TimestampGT(v time.Time) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldTimestamp), v))
	})
}

// TimestampGTE applies the GTE predicate on the "timestamp" field.
func TimestampGTE(v time.Time) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldTimestamp), v))
	})
}

// TimestampLT applies the LT predicate on the "timestamp" field.
func TimestampLT(v time.Time) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldTimestamp), v))
	})
}

// TimestampLTE applies the LTE predicate on the "timestamp" field.
func TimestampLTE(v time.Time) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldTimestamp), v))
	})
}

// WorkflowMsEQ applies the EQ predicate on the "workflow_ms" field.
func WorkflowMsEQ(v int64) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldWorkflowMs), v))
	})
}

// WorkflowMsNEQ applies the NEQ predicate on the "workflow_ms" field.
func WorkflowMsNEQ(v int64) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldWorkflowMs), v))
	})
}

// WorkflowMsIn applies the In predicate on the "workflow_ms" field.
func WorkflowMsIn(vs ...int64) predicate.Metrics {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Metrics(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.In(s.C(FieldWorkflowMs), v...))
	})
}

// WorkflowMsNotIn applies the NotIn predicate on the "workflow_ms" field.
func WorkflowMsNotIn(vs ...int64) predicate.Metrics {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Metrics(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.NotIn(s.C(FieldWorkflowMs), v...))
	})
}

// WorkflowMsGT applies the GT predicate on the "workflow_ms" field.
func WorkflowMsGT(v int64) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldWorkflowMs), v))
	})
}

// WorkflowMsGTE applies the GTE predicate on the "workflow_ms" field.
func WorkflowMsGTE(v int64) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldWorkflowMs), v))
	})
}

// WorkflowMsLT applies the LT predicate on the "workflow_ms" field.
func WorkflowMsLT(v int64) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldWorkflowMs), v))
	})
}

// WorkflowMsLTE applies the LTE predicate on the "workflow_ms" field.
func WorkflowMsLTE(v int64) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldWorkflowMs), v))
	})
}

// IsolateMsEQ applies the EQ predicate on the "isolate_ms" field.
func IsolateMsEQ(v int64) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldIsolateMs), v))
	})
}

// IsolateMsNEQ applies the NEQ predicate on the "isolate_ms" field.
func IsolateMsNEQ(v int64) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldIsolateMs), v))
	})
}

// IsolateMsIn applies the In predicate on the "isolate_ms" field.
func IsolateMsIn(vs ...int64) predicate.Metrics {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Metrics(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.In(s.C(FieldIsolateMs), v...))
	})
}

// IsolateMsNotIn applies the NotIn predicate on the "isolate_ms" field.
func IsolateMsNotIn(vs ...int64) predicate.Metrics {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Metrics(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.NotIn(s.C(FieldIsolateMs), v...))
	})
}

// IsolateMsGT applies the GT predicate on the "isolate_ms" field.
func IsolateMsGT(v int64) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldIsolateMs), v))
	})
}

// IsolateMsGTE applies the GTE predicate on the "isolate_ms" field.
func IsolateMsGTE(v int64) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldIsolateMs), v))
	})
}

// IsolateMsLT applies the LT predicate on the "isolate_ms" field.
func IsolateMsLT(v int64) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldIsolateMs), v))
	})
}

// IsolateMsLTE applies the LTE predicate on the "isolate_ms" field.
func IsolateMsLTE(v int64) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldIsolateMs), v))
	})
}

// ErrorCodeEQ applies the EQ predicate on the "error_code" field.
func ErrorCodeEQ(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldErrorCode), v))
	})
}

// ErrorCodeNEQ applies the NEQ predicate on the "error_code" field.
func ErrorCodeNEQ(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldErrorCode), v))
	})
}

// ErrorCodeIn applies the In predicate on the "error_code" field.
func ErrorCodeIn(vs ...string) predicate.Metrics {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Metrics(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.In(s.C(FieldErrorCode), v...))
	})
}

// ErrorCodeNotIn applies the NotIn predicate on the "error_code" field.
func ErrorCodeNotIn(vs ...string) predicate.Metrics {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Metrics(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.NotIn(s.C(FieldErrorCode), v...))
	})
}

// ErrorCodeGT applies the GT predicate on the "error_code" field.
func ErrorCodeGT(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldErrorCode), v))
	})
}

// ErrorCodeGTE applies the GTE predicate on the "error_code" field.
func ErrorCodeGTE(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldErrorCode), v))
	})
}

// ErrorCodeLT applies the LT predicate on the "error_code" field.
func ErrorCodeLT(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldErrorCode), v))
	})
}

// ErrorCodeLTE applies the LTE predicate on the "error_code" field.
func ErrorCodeLTE(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldErrorCode), v))
	})
}

// ErrorCodeContains applies the Contains predicate on the "error_code" field.
func ErrorCodeContains(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.Contains(s.C(FieldErrorCode), v))
	})
}

// ErrorCodeHasPrefix applies the HasPrefix predicate on the "error_code" field.
func ErrorCodeHasPrefix(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.HasPrefix(s.C(FieldErrorCode), v))
	})
}

// ErrorCodeHasSuffix applies the HasSuffix predicate on the "error_code" field.
func ErrorCodeHasSuffix(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.HasSuffix(s.C(FieldErrorCode), v))
	})
}

// ErrorCodeIsNil applies the IsNil predicate on the "error_code" field.
func ErrorCodeIsNil() predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.IsNull(s.C(FieldErrorCode)))
	})
}

// ErrorCodeNotNil applies the NotNil predicate on the "error_code" field.
func ErrorCodeNotNil() predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.NotNull(s.C(FieldErrorCode)))
	})
}

// ErrorCodeEqualFold applies the EqualFold predicate on the "error_code" field.
func ErrorCodeEqualFold(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.EqualFold(s.C(FieldErrorCode), v))
	})
}

// ErrorCodeContainsFold applies the ContainsFold predicate on the "error_code" field.
func ErrorCodeContainsFold(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.ContainsFold(s.C(FieldErrorCode), v))
	})
}

// InvokerEQ applies the EQ predicate on the "invoker" field.
func InvokerEQ(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldInvoker), v))
	})
}

// InvokerNEQ applies the NEQ predicate on the "invoker" field.
func InvokerNEQ(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldInvoker), v))
	})
}

// InvokerIn applies the In predicate on the "invoker" field.
func InvokerIn(vs ...string) predicate.Metrics {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Metrics(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.In(s.C(FieldInvoker), v...))
	})
}

// InvokerNotIn applies the NotIn predicate on the "invoker" field.
func InvokerNotIn(vs ...string) predicate.Metrics {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Metrics(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.NotIn(s.C(FieldInvoker), v...))
	})
}

// InvokerGT applies the GT predicate on the "invoker" field.
func InvokerGT(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldInvoker), v))
	})
}

// InvokerGTE applies the GTE predicate on the "invoker" field.
func InvokerGTE(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldInvoker), v))
	})
}

// InvokerLT applies the LT predicate on the "invoker" field.
func InvokerLT(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldInvoker), v))
	})
}

// InvokerLTE applies the LTE predicate on the "invoker" field.
func InvokerLTE(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldInvoker), v))
	})
}

// InvokerContains applies the Contains predicate on the "invoker" field.
func InvokerContains(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.Contains(s.C(FieldInvoker), v))
	})
}

// InvokerHasPrefix applies the HasPrefix predicate on the "invoker" field.
func InvokerHasPrefix(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.HasPrefix(s.C(FieldInvoker), v))
	})
}

// InvokerHasSuffix applies the HasSuffix predicate on the "invoker" field.
func InvokerHasSuffix(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.HasSuffix(s.C(FieldInvoker), v))
	})
}

// InvokerEqualFold applies the EqualFold predicate on the "invoker" field.
func InvokerEqualFold(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.EqualFold(s.C(FieldInvoker), v))
	})
}

// InvokerContainsFold applies the ContainsFold predicate on the "invoker" field.
func InvokerContainsFold(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.ContainsFold(s.C(FieldInvoker), v))
	})
}

// NextEQ applies the EQ predicate on the "next" field.
func NextEQ(v int8) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldNext), v))
	})
}

// NextNEQ applies the NEQ predicate on the "next" field.
func NextNEQ(v int8) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldNext), v))
	})
}

// NextIn applies the In predicate on the "next" field.
func NextIn(vs ...int8) predicate.Metrics {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Metrics(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.In(s.C(FieldNext), v...))
	})
}

// NextNotIn applies the NotIn predicate on the "next" field.
func NextNotIn(vs ...int8) predicate.Metrics {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Metrics(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.NotIn(s.C(FieldNext), v...))
	})
}

// NextGT applies the GT predicate on the "next" field.
func NextGT(v int8) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldNext), v))
	})
}

// NextGTE applies the GTE predicate on the "next" field.
func NextGTE(v int8) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldNext), v))
	})
}

// NextLT applies the LT predicate on the "next" field.
func NextLT(v int8) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldNext), v))
	})
}

// NextLTE applies the LTE predicate on the "next" field.
func NextLTE(v int8) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldNext), v))
	})
}

// TransitionEQ applies the EQ predicate on the "transition" field.
func TransitionEQ(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldTransition), v))
	})
}

// TransitionNEQ applies the NEQ predicate on the "transition" field.
func TransitionNEQ(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldTransition), v))
	})
}

// TransitionIn applies the In predicate on the "transition" field.
func TransitionIn(vs ...string) predicate.Metrics {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Metrics(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.In(s.C(FieldTransition), v...))
	})
}

// TransitionNotIn applies the NotIn predicate on the "transition" field.
func TransitionNotIn(vs ...string) predicate.Metrics {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Metrics(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.NotIn(s.C(FieldTransition), v...))
	})
}

// TransitionGT applies the GT predicate on the "transition" field.
func TransitionGT(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldTransition), v))
	})
}

// TransitionGTE applies the GTE predicate on the "transition" field.
func TransitionGTE(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldTransition), v))
	})
}

// TransitionLT applies the LT predicate on the "transition" field.
func TransitionLT(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldTransition), v))
	})
}

// TransitionLTE applies the LTE predicate on the "transition" field.
func TransitionLTE(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldTransition), v))
	})
}

// TransitionContains applies the Contains predicate on the "transition" field.
func TransitionContains(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.Contains(s.C(FieldTransition), v))
	})
}

// TransitionHasPrefix applies the HasPrefix predicate on the "transition" field.
func TransitionHasPrefix(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.HasPrefix(s.C(FieldTransition), v))
	})
}

// TransitionHasSuffix applies the HasSuffix predicate on the "transition" field.
func TransitionHasSuffix(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.HasSuffix(s.C(FieldTransition), v))
	})
}

// TransitionIsNil applies the IsNil predicate on the "transition" field.
func TransitionIsNil() predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.IsNull(s.C(FieldTransition)))
	})
}

// TransitionNotNil applies the NotNil predicate on the "transition" field.
func TransitionNotNil() predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.NotNull(s.C(FieldTransition)))
	})
}

// TransitionEqualFold applies the EqualFold predicate on the "transition" field.
func TransitionEqualFold(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.EqualFold(s.C(FieldTransition), v))
	})
}

// TransitionContainsFold applies the ContainsFold predicate on the "transition" field.
func TransitionContainsFold(v string) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s.Where(sql.ContainsFold(s.C(FieldTransition), v))
	})
}

// And groups predicates with the AND operator between them.
func And(predicates ...predicate.Metrics) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s1 := s.Clone().SetP(nil)
		for _, p := range predicates {
			p(s1)
		}
		s.Where(s1.P())
	})
}

// Or groups predicates with the OR operator between them.
func Or(predicates ...predicate.Metrics) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		s1 := s.Clone().SetP(nil)
		for i, p := range predicates {
			if i > 0 {
				s1.Or()
			}
			p(s1)
		}
		s.Where(s1.P())
	})
}

// Not applies the not operator on the given predicate.
func Not(p predicate.Metrics) predicate.Metrics {
	return predicate.Metrics(func(s *sql.Selector) {
		p(s.Not())
	})
}
